/*
 * WallFire -- a comprehensive firewall administration tool.
 * 
 * Copyright (C) 2001 Herv Eychenne <rv@wallfire.org>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#ifndef _WF_FIREWALL_H
#define _WF_FIREWALL_H

#include <string>

#include "wfhost.h"

/**
 * firewall: it's a particular type of host. It has a firewalling tool.
 */
class wf_firewall : public wf_host {
 public:
  wf_firewall();
  virtual ~wf_firewall();
  // wf_firewall(const wf_firewall&);
  
  bool fwtool_guess();
  bool guess(bool skip_useless = false);

  void fwtool_set(const string& fwtool);
  const string& fwtool_get() const;
  
  ostream& debugprint(ostream& os) const;
  
 private:
  string _fwtool;
  /* add fwtool version RV@@5 */
};

#endif
